<template lang="pug">
  .dashboard(:class="{ 'tabs': userCollages.total, 'logged-out': !user || user.roles.find(role => role === 'guest') }")
    header
      .header-title
        .title create photo
        .spacer
        auth(@ready="ready")
      .tabs(v-if="userCollages.total")
        .tab(
          :class="{ active: currentTabName === TAB_TEMPLATES }"
          @click="currentTabName = TAB_TEMPLATES"
        ) Templates
        .tab(
          v-if="userCollages.total"
          :class="{ active: currentTabName === TAB_MY_COLLAGES }"
          @click="currentTabName = TAB_MY_COLLAGES"
        )
          .text My Photos
          .badge {{ userCollages.total }}

    .scroll-container(v-app-scroll)
      div
        transition(v-if="show" name="slide-fade" mode="out-in")
          .collages-container(v-if="currentTabName === TAB_TEMPLATES" :key="TAB_TEMPLATES")
            .collages
              .new(@click="startFromScratch()")
                .new-container
                  .plus
                    .plus-icon(v-html="$icons.plus")
                  .add-text Create new photo
              .collage.template(
                v-for="template in templates"
                @click="selectTemplate(template)"
                ref="collage"
              )
                img(
                  :src="template.preview.url"
                  :style="getImageStyles(template)"
                )
          .collages-container(v-if="currentTabName === TAB_MY_COLLAGES && userCollages.total" :key="TAB_MY_COLLAGES")
            .collages
              .new(@click="startFromScratch()")
                .new-container
                  .plus
                    .plus-icon(v-html="$icons.plus")
                  .add-text Create new photo
              .collage.user-collage(
                v-for="(collage, index) in userCollages.items"
                @click="selectCollage(collage)"
                ref="collage"
              )
                transition(name="fade")
                  .restore(
                    v-if="collage.isDeleted"
                    @click.stop
                  )
                    .restore-text-mobile Your collage has been deleted.&nbsp;
                    .restore-button-mobile(@click.stop="restoreCollage(collage)")
                      span Undo
                    .restore-button
                      span.restore-text Your collage has been deleted.&nbsp;
                      span.restore-link(@click.stop="restoreCollage(collage)") Undo
                .info(v-if="!collage.isDeleted")
                  .duplicate-button(
                    @click.stop="duplicateCollage(collage, index)"
                    v-tooltip:bottom="'Duplicate'"
                  )
                    .button-loader(v-if="collage.isDuplicating")
                    .icon(
                      v-else
                      v-html="$icons.copy"
                    )
                  .delete-button(
                    @click.stop="deleteCollage(collage, index)"
                    v-tooltip:bottom="'Delete'"
                  )
                    .button-loader(v-if="collage.isDeleting")
                    .icon(
                      v-else
                      v-html="$icons.bin"
                    )
                  .details
                    .info-text Last edit
                    .info-date {{ getDate(collage.updated) }}
                img(
                  v-if="collage.preview"
                  :src="collage.preview.url"
                )
</template>

<script>
import { mapState } from 'vuex'
import photosApi from '../api/photos'
import dataService from '../services/data'

const TAB_TEMPLATES = 'TEMPLATES'
const TAB_MY_COLLAGES = 'USER_COLLAGES'

export default {
  props: {
    tabName: {
      default: TAB_TEMPLATES,
      type: String
    },
    templates: {
      type: Array,
      required: true
    }
  },
  data () {
    return {
      show: false,
      isDuplicating: false,
      isDeleting: false,
      currentTabName: this.tabName,
      TAB_TEMPLATES,
      TAB_MY_COLLAGES
    }
  },
  computed: {
    ...mapState({
      user: state => state.editor.user,
      userCollages: state => state.editor.userCollages
    })
  },
  methods: {
    startFromScratch () {
      this.$router.push(`/creator/new`)
    },
    selectTemplate (template) {
      this.$router.push(`/creator/template/${template.id}`)
    },
    selectCollage (collage) {
      this.$router.push(`/creator/photo/${collage.id}`)
    },
    duplicateCollage (collage) {
      this.$store.dispatch('updateCollage', { id: collage.id, isDuplicating: true })
      dataService.duplicateCollage(collage, false)
        .then(duplicate => {
          this.$store.dispatch('updateCollage', { id: collage.id, isDuplicating: false })
        })
        .catch(() => {
          this.$store.dispatch('updateCollage', { id: collage.id, isDuplicating: false })
          this.$store.dispatch('errorsSet', { api: `We couldn't duplicate collage. Please, try again later.` })
        })
    },
    deleteCollage (collage, index) {
      this.$store.dispatch('updateCollage', { id: collage.id, isDeleting: true })
      photosApi.deleteUserCollage(collage)
        .then(() => {
          this.$store.dispatch('updateCollage', {
            id: collage.id,
            isDeleting: false,
            isDeleted: true
          })
          this.$store.dispatch('setUserCollages', { total: this.userCollages.total - 1 })
          this.$store.dispatch('updateCollage', {
            id: collage.id,
            deletingTimer: setTimeout(() => {
              this.$store.dispatch('updateCollage', { id: collage.id, deletingTimer: null })
              this.$store.dispatch('setUserCollages', { items: this.userCollages.items.filter(userCollage => userCollage.id !== collage.id) })

              // If there is no one collages left - show templates
              if (!this.$store.state.editor.userCollages.total) {
                this.currentTabName = this.TAB_TEMPLATES
              }
            }, 3000)
          })
        })
    },
    restoreCollage (collage) {
      clearTimeout(collage.deletingTimer)
      photosApi.saveUserCollage({ collage: { deleted: false } }, collage.id)
        .then(() => {
          this.$store.dispatch('updateCollage', {
            id: collage.id,
            deletingTimer: null,
            isDeleted: false
          })
          this.$store.dispatch('setUserCollages', { total: this.userCollages.total + 1 })
        })
    },
    ready (collages) {
      this.show = true
    },
    getDate (timestamp) {
      const date = new Date(timestamp)

      function addZero (i) {
        if (i < 10) {
          i = '0' + i
        }
        return i
      }

      return addZero(date.getDate()) + '.' + addZero(date.getMonth() + 1) + '.' + date.getFullYear()
    },
    getImageStyles (collage) {
      const ratio = collage.data.stage.height / collage.data.stage.width
      let width
      let height
      if (ratio > 1) {
        height = 100
        width = collage.data.stage.width / collage.data.stage.height * 100
      } else {
        width = 100
      }

      return {
        width: width + '%',
        height: height + '%'
      }
    }
  }
}
</script>

<style lang="scss" scoped>
  @import '../assets/css/mixins';
  @import '../assets/css/effects';

  .dashboard {
    color: #fff;

    @media (min-width: 0) {
      padding-top: 24px;
    }
    @media (min-width: 425px) {
      padding-top: 32px;
    }

    .scroll-container {
      /deep/ .simplebar-scrollbar::before {
        background-color: #fff;
      }

      @media (min-width: 0) {
        height: calc(100vh - 68px);
      }
      @media (min-width: 700px) {
        height: calc(100vh - 80px);
      }
    }

    &.tabs {
      .scroll-container {
        @media (min-width: 0) {
          height: calc(100vh - 144px);
        }
        @media (min-width: 700px) {
          height: calc(100vh - 155px);
        }
      }
    }

    &.logged-out {
      .auth {
        @media (min-width: 0) {
          width: 100%;
          height: 56px;
          position: absolute;
          z-index: 20;
          bottom: 12px;
          left: 16px;

          &:after {
            width: 100%;
            height: 80px;
            content: '';
            position: absolute;
            left: -16px;
            bottom: -12px;
            z-index: -1;
            background: linear-gradient(180deg, rgba(33, 33, 33, 0) 0%, #212121 100%);
          }
        }
        @media (min-width: 425px) {
          width: initial;
          height: initial;
          position: initial;
          top: initial;
          left: initial;
          transform: none;
        }

        /deep/ .login-button {
          @media (min-width: 0) {
            width: calc(100% - 32px);
            height: 56px;
          }
          @media (min-width: 425px) {
            width: 176px;
            height: 32px;
          }
        }
      }
    }

    header {
      display: flex;
      flex-direction: column;

      .header-title {
        display: flex;
        flex-direction: row;
        align-items: center;
        padding-bottom: 24px;

        @media (min-width: 0) {
          padding: 0 16px;
        }
        @media (min-width: 425px) {
          padding: 0 32px;
        }
        @media (min-width: 700px) {
          padding: 0 72px;
        }
      }

      .title {
        font-weight: bold;
        text-transform: uppercase;

        @media (min-width: 0) {
          font-size: 24px;
        }
        @media (min-width: 700px) {
          font-size: 32px;
        }
      }

      .tabs {
        display: flex;
        flex-direction: row;
        position: relative;

        @media (min-width: 0) {
          border-top: 1px solid rgba(255, 255, 255, 0.1);
          margin: 20px 0 12px 0;
        }
        @media (min-width: 425px) {
          border-bottom: 1px solid rgba(255, 255, 255, 0.1);
          border-top: none;
          margin: 8px 32px 24px 32px;
        }
        @media (min-width: 700px) {
          margin: 8px 72px 24px 72px;
        }

        .tab {
          position: relative;
          display: flex;
          flex-direction: row;
          align-items: center;
          color: #777777;
          font-size: 14px;
          cursor: pointer;

          @media (min-width: 0) {
            width: 50%;
            display: flex;
            flex-direction: row;
            align-items: center;
            justify-content: center;
            border-top: 2px solid transparent;
            font-size: 16px;
            padding: 12px 0;
          }
          @media (min-width: 425px) {
            width: auto;
            border-bottom: 2px solid transparent;
            border-top: none;
            padding: 8px 16px;
          }

          .badge {
            margin-left: 8px;
            background-color: #777777;
          }

          &.active, &:hover {
            color: #bbb;
            @include delay();

            .badge {
              background-color: #fff;
            }
          }

          &.active::after {
            content: '';
            width: 100%;
            position: absolute;
            left: 0;
            bottom: -4px;
            color: #fff;
            @include delay();

            @media (min-width: 425px) {
              border-bottom: 2px solid #fff;
            }
          }

          &.active::before {
            content: '';
            width: 100%;
            position: absolute;
            left: 0;
            top: -4px;
            color: #fff;
            @include delay();

            @media (min-width: 0) {
              border-top: 2px solid #fff;
            }

            @media (min-width: 425px) {
              border-top: none;
            }
          }
        }
      }
    }

    .collages-container {
      width: 100%;
      display: flex;
      flex-direction: column;
      justify-content: center;
      align-items: center;

      @media (min-width: 0) {
        padding: 0 8px 8px 8px;
      }
      @media (min-width: 425px) {
        padding: 0 24px 24px 24px;
      }
      @media (min-width: 700px) {
        padding: 0 64px 64px 64px;
      }

      .collages {
        width: 100%;
        display: flex;
        flex-direction: row;
        flex-wrap: wrap;

        .collage, .blank, .new {
          position: relative;
          margin: 8px;
          cursor: pointer;
        }

        .collage.user-collage {
          .restore {
            width: 100%;
            height: 100%;
            display: flex;
            flex-direction: column;
            align-items: center;
            justify-content: center;
            position: absolute;
            z-index: 20;
            background-color: rgba(0, 0, 0, 0.8);
            cursor: initial;

            .restore-text {
              @media (min-width: 0) {
                display: none;
              }
              @media (min-width: 425px) {
                display: initial;
              }
            }

            .restore-text-mobile {
              @media (min-width: 0) {
                display: block;
                margin-bottom: 20px;
              }
              @media (min-width: 425px) {
                display: none;
              }
            }

            .restore-button, .restore-button-mobile {
              height: 46px;
              align-items: center;
              justify-content: center;
              background-color: #fff;
              color: #000;
              font-size: 14px;
              border-radius: 100px;
            }

            .restore-button {
              @media (min-width: 0px) {
                display: none;
              }
              @media (min-width: 425px) {
                display: flex;
                width: calc(100% - 80px);
              }
              @media (min-width: 500px) {
                width: calc(100% - 160px);
              }
              @media (min-width: 600px) {
                width: calc(100% - 240px);
              }
              @media (min-width: 700px) {
                font-size: 12px;
                width: calc(100% - 40px);
              }
              @media (min-width: 800px) {
              font-size: 14px;
                width: calc(100% - 80px);
              }
              @media (min-width: 1024px) {
                width: calc(100% - 40px);
              }
              @media (min-width: 1124px) {
                width: calc(100% - 80px);
              }
              @media (min-width: 1400px) {
                width: calc(100% - 80px);
              }
              @media (min-width: 1500px) {
                width: calc(100% - 10px);
              }
            }

            .restore-button-mobile {
              width: 120px;
              font-weight: bold;
              cursor: pointer;

              @media (min-width: 0) {
                display: flex;
              }
              @media (min-width: 425px) {
                display: none;
              }
            }

            &-link {
              font-size: 14px;
              font-weight: bold;
              cursor: pointer;
            }
          }

          .info {
            width: 101%;
            height: 101%;
            display: flex;
            flex-direction: column;
            justify-content: flex-end;
            padding: 0 0 16px 16px;
            position: absolute;
            z-index: 20;

            @media (min-width: 0) {
              opacity: 1;
              background: none;
            }
            @media (min-width: 425px) {
              opacity: 0;
              background: linear-gradient(180deg, rgba(0, 0, 0, 0) 0%, #000000 100%);
            }

            .duplicate-button, .delete-button {
              width: 32px;
              height: 32px;
              display: flex;
              align-items: center;
              justify-content: center;
              position: absolute;
              background-color: rgba(0, 0, 0, 0.4);
              border-radius: 32px;

              @media (min-width: 0) {
                bottom: 12px;
              }
              @media (min-width: 425px) {
                top: 12px;
                bottom: initial;
              }

              .button-loader {
                position: relative;
                @include loading(#fff, 2px, 16px);
              }
            }

            .delete-button {
              right: 12px;

              &:hover {
                background-color: #FF5659;
                @include delay()
              }

              .icon {
                width: 10px;
                height: 17px;
                fill: #fff;
              }
            }

            .duplicate-button {
              right: 52px;

              &:hover {
                background-color: rgba(0, 0, 0, 0.6);
                @include delay()
              }

              .icon {
                width: 10px;
                height: 17px;
                fill: #fff;
              }
            }

            .details {
              @media (min-width: 0) {
                display: none;
              }
              @media (min-width: 425px) {
                display: block;
              }

              &-text {
                color: rgba(255, 255, 255, 0.5);
                font-size: 14px;
              }

              &-date {
                color: #fff;
                font-size: 16px;
              }
            }
          }

          &:hover .info {
            opacity: 1;
            @include delay(0.1s)
          }
        }

        .collage.template {
          display: flex;
          align-items: center;
          justify-content: center;
          opacity: 1;

          &:hover {
            opacity: 0.7;
            @include delay()
          }
        }

        .collage {
          background-color: #262626;
          overflow: hidden;
          border: 1px solid #232323;

          img {
            object-fit: contain;
            height: 100%;
            width: 100%;
            position: absolute;
            top: 0;
            z-index: 10;
          }

          @media (min-width: 0px) {
            width: 100%;
            padding-bottom: 65%;
          }
          @media (min-width: 700px) {
            width: calc(50% - 16px);
            padding-bottom: 31%;
          }
          @media (min-width: 1024px) {
            width: calc(33.333% - 16px);
            padding-bottom: 21%;
          }
          @media (min-width: 1440px) {
            width: calc(25% - 16px);
            padding-bottom: 15.8%;
          }
          @media (min-width: 1900px) {
            width: calc(16.666% - 16px);
            padding-bottom: 10.4%;
          }
        }

        .new {
          display: flex;
          position: relative;
          flex-direction: column;
          align-items: center;
          justify-content: center;
          font-weight: bold;
          border: 1px dashed #444444;

          .new-container {
            display: flex;
            flex-direction: column;
            align-items: center;
            justify-content: center;
            position: absolute;
            top: 50%;
            left: 50%;
            transform: translate(-50%, -50%);
          }

          @media (min-width: 0) {
            padding: 8px;
            width: 100%;
            padding-bottom: 64%;
          }
          @media (min-width: 700px) {
            width: calc(50% - 16px);
            height: auto;
            padding-bottom: 30%;
          }
          @media (min-width: 1024px) {
            width: calc(33.333% - 16px);
            padding: 28px;
            padding-bottom: 18%;
          }
          @media (min-width: 1440px) {
            width: calc(25% - 16px);
            padding-bottom: 13%;
          }
          @media (min-width: 1900px) {
            width: calc(16.666% - 16px);
            padding-bottom: 8%;
          }

          .plus {
            width: 60px;
            height: 60px;
            display: flex;
            flex-direction: column;
            align-items: center;
            justify-content: center;
            border-radius: 60px;
            background-color: #484848;
            margin: 0 0 24px 0;

            .plus-icon {
              width: 32px;
              height: 32px;
            }
          }

          .add-text {
            font-size: 16px;
            font-weight: normal;
          }

          &:hover {
            background-color: #212121;
            @include delay()
          }
        }
      }

      .button {
        width: 100px;
        margin-top: 24px;
      }
    }
  }
</style>
